Kerbal Space Program - Bug #4874

Launch clamps appearing in mid air, following ship when outside of the launch pad safe area
05/01/2015 05:13 PM - Kasuha

Status: Closed Start date: 05/01/2015
Severity: Normal % Done: 100%
Assignee:

Category: Physics

Target version:

Version: 1.04 Language: English (US)
Platform: Win32 Mod Related: No
Expansion:

Description

If a launch Clamp is placed outside of the safe area on the launchpad the clamp can be seen to follow the vessel.
Reproduction

1. Open KerbalX in the VAB

2. Move the whole vessel such that a launch clamp is outside of the following floor markings:
o The large circle
o within the small squares either side

3. Launch the vessel and observe the flight.

Observed

A launch clamp can be seen to fall past the craft in flight at around 6000m, and every subsequent 6000m mark.
The launch clamp may follow the craft into space.

Notes

The large thick circle, and the two small squares either side of the VAB floor mark the bounds of the launch pad. Exceeding or getting
very close to these bounds with a launch clamp can trigger this bug. If this cannot be avoided, saving the game (Alt+F5) immediately
after launch and then reloading (Alt+F9) will clear the condition.

Original report follows:

| first noticed it when trying to fly a huge ship (almost 2000 parts, see attached image including clamps), then | reduced it to around
500 parts of initial setup. The issue is deterministically reproducible on my PC but might depend on how powerful the PC is.

In the described case, launch clamps appear at 6000, 12000, 18000, and 24000 meters, then if | keep switching between ship and
them they spawn near the ship and follow it. They are material and can destroy the ship if it rotates in a way that makes them spawn
over ship's parts.

The scenario is harder to reproduce or fails to reproduce with less parts - suggests it's some kind of race condition where cleanup of
physics frame does not finish before it is used or something like that.

Reproduction:

- load the attached quicksave

- set full throttle

- press Space to launch

- wait till the ship reaches 6000 m. At that point, a "click" can be usually heard in the rocket's noise. Use [ or ] to switch to spawned
clamps.

Image album documenting the reproduction scenario as run on my PC:
http://imgur.com/a/662vV

Related issues:

Has duplicate Kerbal Space Program - Bug #5033: Launch clamps grab onto your ... Duplicate 05/23/2015
Has duplicate Kerbal Space Program - Bug #5133: Launch clamps warp to ships I... Duplicate 06/14/2015
Has duplicate Kerbal Space Program - Bug #5230: Flying launch clamps. Duplicate 07/11/2015
History

#1 - 05/01/2015 09:47 PM - Kasuha

| have just verified that the issue is still present on 1.0.2

#2 - 05/11/2015 03:58 PM - McSchwartz
- Status changed from New to Confirmed

- % Done changed from 0 to 10

| don't know how to reproduce this, but | had these clamps appear at Kerbin orbit, 70 km up. | was trying to switch to a different ship using the [ and ]
keys, and it switched to the clamps, floating in orbit. | was unable to switch away from the clamps, as the game would say "Unable to switch crafts
while under acceleration". | was completely stuck and had to revert to launch.

#3 - 05/26/2015 06:50 AM - Squelch
- Has duplicate Bug #5033: Launch clamps grab onto your craft midflight added

#4 - 07/01/2015 08:00 PM - Squelch
- Related to Bug #5133: Launch clamps warp to ships location every 6 km added

#5 - 07/02/2015 12:53 PM - Probus

- Status changed from Confirmed to Investigating
- Severity changed from Normal to High

- % Done changed from 10 to 20

- Version changed from 1.0 to 1.0.4

- Platform Linux added

| have a 100% reproducible save game. | am in the process of investigating to shed more light on the problem. Will post logs and findings shortly.

#6 - 07/02/2015 01:03 PM - Squelch
- Related to deleted (Bug #5133: Launch clamps warp to ships location every 6 km)

#7 - 07/02/2015 01:03 PM - Squelch
- Has duplicate Bug #5133: Launch clamps warp to ships location every 6 km added

#8 - 07/02/2015 03:43 PM - Squelch

Observations:

The craft and quicksave in the original report do cause issues with performance beyond what | would expect for a similarly sized craft. The framerate
at launch drops significantly and does seem much less than what the performance debug screen reports. | am seeing a reported 27.5fps, but the
launch looks like slow motion and much less than this until the craft clears the 2.5km mark where the fps suddenly picks up again. Whether this is a
graphics or simulation frame rate reduction is unclear. The UT display is constantly yellow up to the 2.5km mark.

The clamps do appear to respawn and drop past the vessel once 6km is reached. No log entries are seen.

Attempting to revert to launch while the craft is within the 2.5km distance causes an irrecoverable lockup and partially rendered pause menu on my
Win7 machine accompanied by constant spam to the log of the following.

[EXC 16:25:07.630] NullReferenceException: Object reference not set to an instance of an object
PauseMenu.drawRevertOptions ()
MultiOptionDialog.drawContent (Int32 id)
UnityEngine.GUILayout+LayoutedWindow.DoWindow (Int32 windowID)
UnityEngine.GUI.CallWindowDelegate (UnityEngine.WindowFunction func, Int32 id, UnityEngine.GUISkin _skin,
Int32 forceRect, Single width, Single height, UnityEngine.GUIStyle style)

#9 - 07/02/2015 08:39 PM - Kasuha
- File Mid Air Clamps - no probe cores.craft added

Performance (framerate) impact in bottom 2.5 km is probably related to number of probe cores | used as ballast parts - perhaps extra heat
generation/processing? After replacing them with structural panels, the launch performance is ok and the initial reported problem (launch clamps
teleporting to mid air) remains - at least on my PC.

Uploading updated craft file with probe cores replaced by structural panels.
#10 - 07/02/2015 11:33 PM - Probus

- File ClampBuddy.jpg added

Nothing in the log files during mid-air clamp creation.

| can repeat every time using a 4 part stock craft and a tall FASA launch umbilical.

When the FASA part is switched out with the stock clamp | can hear the sound anomaly every 6 km but | don't see the stock clamp "falling".
When both the FASA and stock clamps are attached only the FASA clamp appears in mid air. Sometimes they follow the craft up at 5.7 km.
The game is modded.

#11 - 07/03/2015 03:37 PM - Squelch

- File #4874-Mid Air Clamps -minimal.craft added

- File #4874-Flight status.PNG added

Thanks for the new craft Kasuha, the performance is much better as a result.

| have distilled the craft to the minimum parts required for the Launch Clamps to keep spawning in mid air. I'm not sure of the function for the "ballast"
parts, but I've found them to be superfluous.

#4874-Mid Air Clamps -minimal

Further observations:

Placing all launch clamps in the first stage stops the behaviour.
The launch clamp assemblies that are not on the launchpad are recorded as structurally failing

1#4874-Flight status.PNG!

Moving the whole craft so that both clamps are on the pad stops the behaviour.

Saving the game (ALT+F9) at ~1500m and comparing to another non bugged launch shows no differences.
Saving the game at ~1500m and immediately reloading does not produce the behaviour.

The first mid-air clamp coincides with the Kerbal portrait darkening.

#12 - 07/03/2015 04:09 PM - Squeich
Using KerbalX (stock) and positioning the whole craft left so that the launch clamp is in the small square box will cause this bug.
Conclusion: The rooted part of the clamp must be within the bounds of the large circle in the VAB. The small squared areas are also out of bounds.

#13 - 07/03/2015 04:40 PM - Squelch

- Subject changed from Launch clamps appearing in mid air, following ship to Launch clamps appearing in mid air, following ship when outside of the
launch pad safe area

- Description updated

| have updated the title and description for information. This will be passed to the devs for attention.

#14 - 07/03/2015 04:40 PM - Squelch

- Status changed from Investigating to Confirmed
- Severity changed from High to Normal

- % Done changed from 20 to 10

#15 - 07/03/2015 04:53 PM - Squeich

- Description updated

#17 - 07/11/2015 03:34 PM - Squelch

- Description updated

#18 - 07/11/2015 03:39 PM - Squelch
- Has duplicate Bug #5230: Flying launch clamps. added

#19 - 07/27/2015 05:57 PM - Squelch
http://bugs.kerbalspaceprogram.com/attachments/download/7013/%234874-Mid%20Air%20Clamps%20-minimal.craft

- Platform Win32 added
- Platform deleted (Linux, Windows)

#20 - 11/17/2015 02:12 PM - sal_vager
- Status changed from Confirmed to Resolved

- % Done changed from 10 to 100

No longer occurs on 1.0.5, build 1028

#21 - 07/17/2016 09:19 AM - TriggerAu

- Status changed from Resolved to Closed

Files

quicksave.sfs

screenshot41.png

Mid Air Clamps.craft

Mid Air Clamps - no probe cores.craft
ClampBuddy.jpg

#4874-Mid Air Clamps -minimal.craft
#4874-Flight status.PNG
